unit uGUI; { mk, 7.4.2004 }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,mTAutomat;

type
  TForm1 = class(TForm)
    mEingaben: TMemo; mAusgaben: TMemo; lZustand: TLabel; lEingabe: TLabel;
    lAusgabe: TLabel;
    bVerarbeite: TButton; lEingaben: TLabel; lAusgaben: TLabel;
    cbZustand: TComboBox; cbEingabe: TComboBox; cbAusgabe: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bVerarbeiteClick(Sender: TObject);
  private
    automat : TAutomat;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  z   : TZustand;
  e   : TEingabe;
  a   : TAusgabe;
begin
  automat := TAutomat.Create;
  // Name des Automaten
  Form1.Caption := automatname;
  // Zustnde in ComboBox eintragen
  z := Low(TZustand);
  while z < High(TZustand) do
  begin
    cbZustand.AddItem(zText[z],nil);
    z := Succ(z); // oder Inc(z);
  end;
  cbZustand.AddItem(zText[z],nil);
  cbZustand.ItemIndex := Ord(automat.getZustand);
  // Eingabealphabet in ComboBox eintragen
  e := Low(TEingabe);
  while e < High(TEingabe) do
  begin
    cbEingabe.AddItem(eText[e],nil);
    e := Succ(e);
  end;
  cbEingabe.AddItem(eText[e],nil);
  cbEingabe.ItemIndex := 0;
  // Ausgabealphabet in ComboBox eintragen
  a := Low(TAusgabe);
  while a < High(TAusgabe) do
  begin
    cbAusgabe.AddItem(aText[a],nil);
    a := Succ(a);
  end;
  cbAusgabe.AddItem(aText[a],nil);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  automat.Free;
end;

procedure TForm1.bVerarbeiteClick(Sender: TObject);
begin
  if (cbZustand.ItemIndex <> -1) and (cbEingabe.ItemIndex <> -1)
  then
  begin
    automat.setZustand(TZustand(cbZustand.ItemIndex));
    automat.setEingabe(TEingabe(cbEingabe.ItemIndex));
    automat.verarbeiteEingabe;
    mEingaben.Lines.Add(eText[automat.getEingabe]);
    cbZustand.ItemIndex := Ord(automat.getZustand);
    cbAusgabe.ItemIndex := Ord(automat.getAusgabe);
    mAusgaben.Lines.Add(aText[automat.getAusgabe]);
  end;
end;

end.
